/*URL Lock*/

/*This file implement URL blocking and Link disable*/

/*add load event when the new browser was loaded*/
window.addEventListener("load", loadWindow, false);
/*Add pageshow event when page is loaded*/
window.addEventListener("pageshow", initLoad, false);

/*This function adds a new progress listener when the window is loaded*/
function loadWindow() {
	var browser = gBrowser;
	browser.addProgressListener(new progressListener() );
}

/*This function implement the progress listenner event*/
function progressListener() {
	this.onLocationChange = function(webProgress, request, status, message) {
		if (request != null) {
			initStartLoad(webProgress.DOMWindow);
		}
	};
	this.onStatusChange = function(){};
	this.onProgressChange = function(){};
	this.onStateChange = function(){};
	this.onSecurityChange = function(){};
	
}

/*This function is called when the new browser is loaded*/
function initStartLoad(browserWindow) {
	var browser = getBrowserForDocument(browserWindow.document);
    var currentLink = browser.contentDocument.location;
	if (lockEngine.isLocationBlocked(currentLink.href)){
		browser.loadURI("chrome://urlLock/content/lockWarning.html?" + currentLink.href);
	}
}

/*This function is called when a page is loaded*/
function initLoad(evt) {
	var browser = getBrowserForDocument(evt.originalTarget);
	var allLinks = browser.contentDocument.getElementsByTagName('a');
	if (browser.currentURI.host.indexOf("google.com") > 0) {
		for (i = 0; i < allLinks.length; i++) {
			googleDisableOne(allLinks[i]);
		}
	}
	else {
		for (i = 0; i < allLinks.length; i++) {		
			applyDisableOne(allLinks[i]);
		}
	}
}
	

/* Returns the browser for the given document
Code adapted from Firefox 2 code at
http://lxr.mozilla.org/seamonkey/source/toolkit/content/widgets/tabbrowser.xml */
function getBrowserForDocument(document) {
  var browser;
  for (var i = 0; i < gBrowser.mPanelContainer.childNodes.length; i++) {
	browser = gBrowser.getBrowserAtIndex(i);
	if (browser.contentDocument == document) {
	  return browser;
	}
  }
  return null;
}	


/*Disable links which matches the blocking role*/
function applyDisableOne(link) {
	if (lockEngine.isLocationBlocked(link.href)) {
		disableLink(link);
		setDisabledColor(link);
	}
}


/*Apply only for google, disable links which matches the blocking role*/
function googleDisableOne(link) {
	if (lockEngine.isLocationBlocked(link.href)) {
		disableLink(link);
		if (link.parentNode != null && link.parentNode.tagName == "H2" &&
			link.parentNode.parentNode != null && link.parentNode.parentNode.tagName == "DIV") {
			
			setDisabledColor(link.parentNode.parentNode);
			
			if (link.parentNode != null && link.parentNode.tagName == "H2") {
				insertLockIcon();
			}
		}
		else {
			setDisabledColor(link);
		}
	}
	
}

//Insert after the given link
function insertLockIcon() {
	image = document.createElement("img");
	image.setAttribute("src", "chrome://urlLock/skin/lockIcons_15.png");
}

//Apply for disable any link
function disableLink(link) {
	
	link.setAttribute("onClick", "return false");
	
	if (link.parentNode.parentNode.hasChildNodes())
	{
		var children = link.parentNode.parentNode.childNodes;
		var newParent = children[2];
		
			if(newParent.hasChildNodes())
			{
				var newthing = newParent.childNodes[0];
				
				
				var cached = newParent.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[5].childNodes[0];
				
				var similarPage = newParent.childNodes[0].childNodes[0].childNodes[0].childNodes[0].childNodes[5].childNodes[2];
				
				cached.setAttribute("onClick", "return false");
				similarPage.setAttribute("onClick", "return false");
			}	
	}
}

/*Change the link color*/
function setDisabledColor(link) {
	link.style.opacity = 0.2;
}
