// URL Lock

//
// This file contains the code for the Add New Rule window
//

// Global rule object for this window
var rule;

function openBookmark() {

	// Open bookmark
	window.open("bookMarkPanel.xul", "Bookmark", "chrome");
}

function openHistory() {

	// Open history
	window.open("historyPanel.xul", "History", "chrome");
}

// Saves URL to the list
function submitChanges() {
	rule.setDomain(document.getElementById('addNewURL').value);
	rule.setName(rule.getDomain());
	handleUserSelection();
	rule.save();
	lockEngine.getConfiguration().addRule(rule);
}

// Select all available users
function selectAllAN() {
	var usersAN = lockEngine.getConfiguration().getUsers();

	for (i=0;i<usersAN.length;i++) {
		document.getElementById('addNewUsers').getItemAtIndex(i).checked=true;
	}
}

// Clear seletions for all availble users
function clearAllAN() {
	var usersAN = lockEngine.getConfiguration().getUsers();
	
	for (i=0;i<usersAN.length;i++) {
		document.getElementById('addNewUsers').getItemAtIndex(i).checked=false;
	}
}

/**
 * Called when this window is created
 */
function initAddNew() {

    // Create a new rule for this add window, but don't add it to the rule
    // list until it is saved
    rule = lockEngine.getConfiguration().createRule();

	// Loads when the dialog box starts
	initAddUserList();
}

/**
 * Handle the selection or deselection of the users
 */
function handleUserSelection() {
   
    // Handle each user in the list
    var users = document.getElementById('addNewUsers');
    var i, count = users.getRowCount();
    var user, userItem;
    for (i = 0; i < count; i++) {

        // Get the user that this event applies to
        userItem = users.getItemAtIndex(i);
        user = lockEngine.getConfiguration().getUser(userItem.value);
   
        // Add or remove this user from this rule depending on the current
        // selected state
        if (userItem.checked) {
            rule.addUser(user);
        } else {
            rule.removeUser(user);
        }
    }
}

/**
 * Populates the user list
 */
function initAddUserList() {
	var users = lockEngine.getConfiguration().getUsers();
	
	// Append available users
	for (i=0; i<users.length;i++) {
		var user = document.getElementById('addNewUsers').appendItem(users.item(i).getFullName(),
		                                                             users.item(i).getUserName());
		user.setAttribute("type","checkbox");
	}
}
